<template>
  <div v-bind:id="divId">
    <!-- Plotly chart will be drawn inside this DIV -->
  </div>
</template>

<script>
import { statMixin } from "./stat-mixin";


export default {
  mixins: [statMixin],
  methods: {
    createPlotly(title) {
      this.layout = {
        showlegend: false,
        title: title,
        xaxis: {
          autorange: true,
          rangeslider: {},
          type: "date",
        },
        yaxis: {
          autorange: true,
          type: "linear",
        },
      };

      return this.$Plotly.newPlot(this.divId, this.traceList,this.layout);
    },
    defineActionForPlotlyEvent() {
      let myPlotly = document.getElementById(this.divId);
      let this2component = this;
      this.fromDate = this.convert2LocalDate(new Date(myPlotly.layout.xaxis.rangeslider.range[0]));
      this.toDate = this.convert2LocalDate(new Date(myPlotly.layout.xaxis.rangeslider.range[1]));   
      myPlotly.on("plotly_relayout", function (eventdata) {
        if (Object.prototype.toString.call(eventdata["xaxis.range"]) === "[object Array]") {
          var x_start = eventdata["xaxis.range"][0];
          var x_end = eventdata["xaxis.range"][1];
          this2component.fromDate = this2component.convert2LocalDate(new Date(x_start));
          this2component.toDate = this2component.convert2LocalDate(new Date(x_end));
          this2component.startTimer(eventdata);
        }
        return true;
      });   
    },
    dateschanged() {
      this.$emitter.emit("dateschanged", [this.fromDate, this.toDate]);     
      this.layout.title= this.compParam.plotly_title + " dal " + this.fromDate + " al " + this.toDate     
      this.$Plotly.react(this.divId,this.traceList,this.layout);
    },
    startTimer() {
      clearTimeout(this.sliderChangeTimer);
      this.sliderChangeTimer = setTimeout(this.dateschanged, 1000);
    },
    createListColorPerTrace() {
      for (let count = 0; count < this.storePerService.listActualMainTraces.length; count++) {
        let color = this.storePerService.listColors[count];
        this.storePerService.colorPerTrace[this.storePerService.listActualMainTraces[count].name] = color;
      }
    },  
    createColorsWithHSV() {    
      let total = this.traceList.length;       
       var i = 350 / (total - 1); // distribute the colors evenly on the hue range   
      var r = []; // hold the generated colors
      for (var x = 0; x < total; x = x + 1) {
        r.push(this.hsv2rgb(i * x, 0.7, 1)); // you can also alternate the saturation and value for even more contrast between the colors
      }      
      return r;
    },
    hsv2rgb(h,s,v)  {                              
        let f= (n,k=(n+h/60)%6) => v - v*s*Math.max( Math.min(k,4-k,1), 0);  
        let resuls = {r:1,g:2};   
        return {r:Math.round(f(5)*255),    g: Math.round(f(3)*255),    b:Math.round(f(1)*255)};       
    }  
  },

  async mounted() {  
      await this.getData(this.fromDate, this.toDate);
      this.createAllTraces(this.compParam.x_column, this.compParam.y_column);
      this.storePerService = this.colorStoreFactory(this.globalStore.selectedService)();
      this.storePerService.listColors = this.createColorsWithHSV();     
      this.storePerService.listActualMainTraces=this.traceList;
      this.createListColorPerTrace();                
      this.setColors2Traces();
      this.$emitter.emit("colorsdefined");
      let title = this.compParam.plotly_title + " dal " + this.fromDate + " al " + this.toDate;
      this.createPlotly(title);   
      this.defineActionForPlotlyEvent();
    }
  }
</script>
